<?php
include('/usr/fallback/beroConf.php');
include('/usr/local/php/include/fulltrace.Class.php');

/**
 * Implements the debug funtions of the gateway
 * @author Florian Kraatz <fk@beronet.com>
 * @author Miguel Palmer <mp@beronet.com>
 */
class FulltraceGui {

	private $_ba;
	private $_bc;
	private $_ft;

	function __construct() {
		$this->_ba = new beroAri();
		$this->_bc = new beroConf('root');
		$this->_ft = new fulltrace();
	}

	function show_network_ifs() {
		
		$ret = '<input type="checkbox" name="lan" id="lan" value="1" checked /><label for="lan">lan</label>&nbsp;&nbsp;';
		
		if ($this->_bc->get('root','lan-mode')=='lan-wan') {
			$ret  .= '<input type="checkbox" name="wan" id="wan" value="1"/><label for="wan">wan</label>';
		}
		return $ret;
	}
	// Die Funktion ports wird benutzt um alle ISDN Ports anzuzeigen.
	function show_isdn_ports() {
		$qu = $this->_ba->select('SELECT * FROM isdn');
		while ($entry = $this->_ba->fetch_array($qu)) {
			// Für jeden Port wird ein checkbox erzeugt
			$select .= '<input type="checkbox" name="ports[]" value="' . $entry['port'] . '" checked /><label for="ports[]">' . $entry['port'] . "</label>\n";
		}

		return($select);
	}

	private function _show_trace_run() {
		ob_start();
		?>
		<br />
		<form method="POST" class="form-horizontal">
			<p class="text-center lead" ><? echo FULL_TRACE_TABLE_HEADER_DIS ?></p>
			<div class='form-group text-center' id="ntphost">
				<img src="includes/images/punkt_gruen.gif" style="margin-right: 15px;">

				<input type="submit" class="btn btn-default" id="trace" name="trace" title="<? echo DEBUG_STOP_TRACE; ?>" data-toggle="tooltip" value="Stop" />
			</div>
		</form><br />
		<?php
		$ret .= ob_get_clean();

		// we don't display file-download during trace if we're not 'advanced'
		if (((strlen($this->_ba->get('gui_mode')) == 0) ? 'easy' : $this->_ba->get('gui_mode')) != 'advanced') {
			return($ret);
		}

		// get data
		foreach ($this->_ft->get_runtime_files() as $ftFile) {
			if (empty($ftFile)) {
				continue;
			}
			$ftFiles[] = array('name' => basename($ftFile), 'size' => filesize($ftFile));
			$fileName[] = basename($ftFile);
			$fileSize[] = filesize($ftFile);
		}

		// sort by file-size
		array_multisort($fileSize, SORT_DESC, $fileName, $ftFiles);

		// output
		ob_start();
		?>
		<hr>
		<p class="text-center lead" ><? echo FULL_TRACE_SINGLE_TABLE_HEADER_DIS ?></p>
		<?php foreach ($ftFiles as $ftFile): ?>
			<form name="download_logfile" action="modules/FulltraceGui/isdn_trace.php?option=single_logfile" method="POST" class="form-horizontal">
				<div class='form-group' id="lan_netmask">
					<label for='logfile_name' class='col-sm-5 control-label'><? echo $ftFile['name']; ?></label>
					<div class='col-sm-1'>
						<? echo round(($ftFile['size'] / 1024), 2); ?> kB
					</div>
					<div class='col-sm-3'>
						<input type="hidden" name="logfile_name" value="<? echo $ftFile['name']; ?>" />
						<input type="submit" class="btn btn-default" value="Download" />
					</div>
				</div>
			</form>
		<?php endforeach; ?>
		<hr>
		<?php
		$ret .= ob_get_clean();

		return($ret);
	}

	function table() {

		$colspan = 2;
		ob_start();

		$query_gsm = $this->_ba->select('SELECT * FROM gsm');
		if (sqlite_num_rows($query_gsm) > 0):
			?>
			<div class='form-group' style="vertical-align: top; margin-left: 25px;">
				<label for='gsm' class='control-label'>GSM</label>
				<div>
					<input type='checkbox' value='1' name='gsm' id='gsm' checked>
					<?php echo FULL_TRACE_ENABLE_DIS; ?>
				</div>
			</div>
			<div class='form-group' style="vertical-align: top; margin-left: 25px;">
				<label for='gsm_sms' class='control-label'>GSM SMS</label>
				<div>
					<input type='checkbox' value='1' name='gsm_sms' id='gsm_sms'>
					<?php echo FULL_TRACE_ENABLE_DIS; ?>
				</div>
			</div>
			<?php
		endif;


		$query_lte = $this->_ba->select('SELECT * FROM lte');
		if (sqlite_num_rows($query_lte) > 0):
			?>
			<div class='form-group' style="vertical-align: top; margin-left: 25px;">
				<label for='lte' class='control-label'>LTE</label>
				<div>
					<input type='checkbox' value='1' name='lte' id='lte' checked>
					<?php echo FULL_TRACE_ENABLE_DIS; ?>
				</div>
			</div>
			<div class='form-group' style="vertical-align: top; margin-left: 25px;">
				<label for='lte_sms' class='control-label'>LTE SMS</label>
				<div>
					<input type='checkbox' value='1' name='lte_sms' id='lte_sms'>
					<?php echo FULL_TRACE_ENABLE_DIS; ?>
				</div>
			</div>
			<?php
		endif;

		$query_analog = $this->_ba->select('SELECT * FROM analog');
		if (sqlite_num_rows($query_analog) > 0) :
			?>
			<div class='form-group' style="vertical-align: top; margin-left: 25px;">
				<label for='analog' class='control-label'>ANALOG</label>
				<div>
					<input type='checkbox' value='1' name='analog' id='analog' checked>
					<?php echo FULL_TRACE_ENABLE_DIS; ?>
				</div>
			</div>
			<?php
		endif;

		$query_analog = $this->_ba->select('SELECT * FROM cas WHERE port_type = \'cas=\'');
		if (sqlite_num_rows($query_analog) > 0) :
			?>
			<div class='form-group' style="vertical-align: top; margin-left: 25px;">
				<label for='cas' class='control-label'>CAS</label>
				<div>
					<input type='checkbox' value='1' name='cas' id='cas'  checked>
					<?php echo FULL_TRACE_ENABLE_DIS; ?>
				</div>
			</div>
			<?php
		endif;
		$tech = ob_get_clean();
		ob_start();
		?>
		<br/>
		<form method='POST' class="form-inline">
			<div style="display:table; margin: 0 auto;">
			<p class="text-center lead" ><? echo FULL_TRACE_TABLE_HEADER_DIS ?></p>
			<div class='form-group' style="vertical-align: top;">
				<label for='cas' class='control-label'><?php echo FULL_TRACE_ISDN_PORTS_DIS; ?></label>
				<div>
					<input type='checkbox' name='isdn_enable' id='isdn_enable' value='1' onclick='dis();' checked/>
					<?php echo FULL_TRACE_ENABLE_DIS; ?>
					<br>
					<input type='checkbox' id='checkall' name='checkall' onclick='checkallp();' title="<?php echo DEBUG_CHECK_ALL; ?>" onmouseout='UnTip()'>
					<strong><?php echo FULL_TRACE_CHECK_ALL_DIS; ?></strong>
					<br>
					<?php echo $this->show_isdn_ports(); ?>
				</div>
			</div>
			<div class='form-group' style="vertical-align: top; margin-left: 25px;">
				<label for='any' class='control-label'><?php echo FULL_TRACE_NETWORK_DIS; ?></label>
				<div>
					<input type="checkbox" name="any" id="any" value="1" />
					<?php echo FULL_TRACE_ANY_TRAFFIC_DIS ?>
					<br>
					<input type="checkbox" name="sip_sign" id="sip_sign" value="1" 
						   onclick="if (sip_sign.checked == true)
		                               sip_audio.disabled = false;
		                           else
		                               sip_audio.disabled = true;" checked/>
					SIP signaling
					<br>
					<input type="checkbox" name="rtp_udptl" id="rtp_udptl" value="1" />
					RTP/UDPTL
					<br>
					<input type='checkbox' name='syslog' id='syslog' value='1' />
					syslog
					<br>
					<strong>Interface</strong>
					<br>
					<input type="checkbox" name="localhost" id="localhost" value="1" />lo&nbsp;&nbsp;
					<?php echo $this->show_network_ifs(); ?>
				</div>
			</div>
			<?php echo $tech; ?>
			</div>
			<br>
			<div class='text-center'>
				<img src='./includes/images/punkt_rot.gif'>&nbsp;&nbsp;&nbsp;
				<input type='submit' class='btn btn-default' id='trace' name='trace' title="<?php echo DEBUG_START_TRACE; ?>" data-toggle="tooltip" 
					   value="<?php echo FULL_TRACE_BUTTON_START_DIS; ?>">
			</div>
		</form><br/>
		<hr>
		<?php
		return ob_get_clean();
	}

	function display() {

		$name = 'FULL_TRACE_TITLE_DIS';
		include('./includes/header.php');
		require_once('./includes/isgwtelnet.php');
		ob_start();
		?>
		<script language="javascript">
		    function checkallp() {
		        var checkall = document.getElementById('checkall');
		        var del = document.getElementsByName('ports[]');
		        if (checkall.checked == true) {
		            for (i = 0; i < del.length; i++) {
		                del[i].checked = true;
		            }
		        } else {
		            for (i = 0; i < del.length; i++) {
		                del[i].checked = false;
		            }
		        }
		    }

		    function dis() {
		        var isdn_enable = document.getElementById('isdn_enable');
		        var checkall = document.getElementById('checkall');
		        var del = document.getElementsByName('ports[]');
		        if (isdn_enable.checked == true) {
		            checkall.disabled = false;
		            for (i = 0; i < del.length; i++) {
		                del[i].disabled = false;
		            }
		        } else {
		            checkall.disabled = true;
		            for (i = 0; i < del.length; i++) {
		                del[i].disabled = true;
		            }
		        }
		    }
		</script>
		<?php
		$ret .= ob_get_clean();

		switch ($_POST['trace']) {
			case 'Start':
				$enable['isdn'] = (($_POST['isdn_enable'] == '1') ? 1 : 0);
				$enable['analog'] = (($_POST['analog'] == '1') ? 1 : 0);
				$enable['gsm'] = (($_POST['gsm'] == '1') ? 1 : 0);
				$enable['gsm_sms'] = (($_POST['gsm_sms'] == '1') ? 1 : 0);
				$enable['lte'] = (($_POST['lte'] == '1') ? 1 : 0);
				$enable['lte_sms'] = (($_POST['lte_sms'] == '1') ? 1 : 0);
				$enable['cas'] = (($_POST['cas'] == '1') ? 1 : 0);
				$enable['sip_sign'] = (($_POST['sip_sign'] == '1') ? 1 : 0);
				$enable['rtp_udptl'] = (($_POST['rtp_udptl'] == '1') ? 1 : 0);
				$enable['any'] = (($_POST['any'] == '1') ? 1 : 0);
				$enable['lan'] = (($_POST['lan'] == '1') ? 1 : 0);
				$enable['wan'] = (($_POST['wan'] == '1') ? 1 : 0);
				$enable['lo'] = (($_POST['localhost'] == '1') ? 1 : 0);
				$enable['syslog'] = (($_POST['syslog'] == '1') ? 1 : 0);
				$this->_ft->start($enable, $_POST['ports'], null);
				unset($enable);
				$ret .= $this->_show_trace_run();
				break;
			case 'Stop':
				$this->_ft->stop(false);
				$ret .= $this->table();
				break;
			default:
				if ($this->_ba->get('trace') == 'yes') {
					$ret .= $this->_show_trace_run();
					break;
				}
				$ret .= $this->table();
				break;
		}
		/*
		  if (((strlen($this->_ba->get('trace')) == 0) || ($this->_ba->get('trace') == 'no')) && !isset($_POST['trace'])) {
		  $ret .= $this->table();
		  } elseif ($_POST['trace'] == 'Start' ) {

		  } else if ($_POST['trace'] == 'Stop') {
		  } else if ($this->_ba->get('trace') == 'yes') {
		  $ret .= $this->_show_trace_run();
		  }
		 */
		/*
		 * Überprüfung ob die dateien debug-info.tar.gz oder DebugFiles.tar.gz oder isgw.err,
		 * Wenn ja, wird einen Link für Download angeboten, und einen Link delete
		 * um die entsprechende Datei zu löschen
		 */
		if (file_exists("/var/log/debug-info.tar.gz") || file_exists("/var/log/DebugFiles.tar.gz") || file_exists("/var/log/isgw.err")) {
			ob_start();
			?>
			<form method='POST' class="form-horizontal">
				<p class="text-center lead" ><? echo FULL_TRACE_DOWNLOADS_DIS ?></p>
				<? if (file_exists("/var/log/debug-info.tar.gz")): ?>
					<div class='form-group'>
						<label for='download' class='col-sm-4 control-label'><? echo FULL_TRACE_ISGW_COREDUMPS_DIS; ?></label>
						<div class='col-sm-3'>
							<input type='button' class='btn btn-default' value='<? echo FULL_TRACE_BUTTON_DOWNLOAD_DIS ?>' 
								   onclick="window.location.href = 'modules/FulltraceGui/isdn_trace.php?option=isgw';" 
								   title="<? echo DEBUG_DOWNLOAD_TRACE; ?> " data-toggle='tooltip'>
							<input type='button' class='btn btn-default' value="<? echo FULL_TRACE_BUTTON_DELETE_FILE_DIS; ?>" 
								   onclick="javascript:if (confirm('<? echo FULL_TRACE_DELETE_COREDUMPS_DIS; ?>?') == true)
				                               window.location.href = 'misc/deletefile.php?m=<? echo $_GET['m']; ?>';" 
								   title="<? echo DEBUG_DELETE; ?>" data-toggle="tooltip">
						</div>
						<div class='col-sm-4'><? echo date("d M Y H:i", filectime("/var/log/debug-info.tar.gz")); ?></div>
					</div>
					<?php
				endif;
				if (file_exists("/var/log/DebugFiles.tar.gz")):
					?>
					<div class='form-group'>
						<label for='download' class='col-sm-4 control-label'><? echo FULL_TRACE_DEBUG_FILES_DIS; ?></label>
						<div class='col-sm-3'>
							<input type='button' class='btn btn-default' value='<? echo FULL_TRACE_BUTTON_DOWNLOAD_DIS ?>' 
								   onclick="window.location.href = 'modules/FulltraceGui/isdn_trace.php';" 
								   title="<? echo DEBUG_DOWNLOAD_TRACE; ?> " data-toggle='tooltip'>
							<input type='button' class='btn btn-default' value="<? echo FULL_TRACE_BUTTON_DELETE_FILE_DIS; ?>" 
								   onclick="javascript:if (confirm('<? echo FULL_TRACE_DELETE_DEBUG_FILES_DIS; ?>?') == true)
				                               window.location.href = 'misc/deletefile.php?m=<? echo $_GET['m']; ?>&option=debug';" 
								   title="<? echo DEBUG_DELETE_FILES; ?>" data-toggle="tooltip">
						</div>
						<div class='col-sm-4'><? echo date("d M Y H:i", filectime("/var/log/DebugFiles.tar.gz")); ?></div>
					</div>
					<?php
				endif;
				if (file_exists("/var/log/isgw.err")):
					?>
					<div class='form-group'>
						<label for='download' class='col-sm-4 control-label'><? echo FULL_TRACE_ERROR_LOG_DIS; ?></label>
						<div class='col-sm-3'>
							<input type='button' class='btn btn-default' value='<? echo FULL_TRACE_BUTTON_DOWNLOAD_DIS ?>' 
								   onclick="window.location.href = 'modules/FulltraceGui/isdn_trace.php?option=error';">
						</div>
						<div class='col-sm-4'><? echo date("d M Y H:i", filectime("/var/log/isgw.err")); ?></div>
					</div>
					<?php
				endif;
				if (file_exists("/var/log/cloud.log")):
					?>
					<div class='form-group'>
						<label for='download' class='col-sm-4 control-label'><? echo FULL_TRACE_CLOUD_LOG_DIS; ?></label>
						<div class='col-sm-3'>
							<input type='button' class='btn btn-default' value='<? echo FULL_TRACE_BUTTON_DOWNLOAD_DIS ?>' 
								   onclick="window.location.href = 'modules/FulltraceGui/isdn_trace.php?option=cloud';">
						</div>
						<div class='col-sm-4'><? echo date("d M Y H:i", filectime("/var/log/cloud.log")); ?></div>
					</div>
				<?php endif; ?>
			</form>
			<br/>
			<?php
			$ret .= ob_get_clean();
		}


		//Rückgabe: Der Inhalt von der HTML-Seite
		return $ret;
	}

}
?>
